<template>
	<el-dialog v-model="visible" :title="!dataForm.id ? '新增' : '修改'" :close-on-click-modal="false">
		<el-form ref="dataFormRef" :model="dataForm" :rules="dataRules" label-width="100px" @keyup.enter="submitHandle()">
			<el-form-item label="书名" prop="bookName">
				<el-input v-model="dataForm.bookName" placeholder=""></el-input>
			</el-form-item>
			<el-form-item label="作者" prop="author">
				<el-input v-model="dataForm.author" placeholder=""></el-input>
			</el-form-item>
			<el-form-item label="价格" prop="price">
				<el-input v-model="dataForm.price" placeholder=""></el-input>
			</el-form-item>
			<el-form-item label="封面" prop="bookCover">
				<el-upload
					class="avatar-uploader"
					action="https://run.mocky.io/v3/9d059bf9-4660-45f2-925d-ce80ad6c4d15"
					:show-file-list="false"
					:on-success="handleAvatarSuccess"
					:before-upload="beforeAvatarUpload"
				>
					<img v-if="dataForm.bookCover" :src="dataForm.bookCover" style="width: 150px" />
					<el-icon v-else class="avatar-uploader-icon"><Plus /></el-icon>
				</el-upload>
			</el-form-item>
			<el-form-item label="书籍类别" prop="category">
				<el-select v-model="dataForm.category" placeholder="书籍类别">
				<el-option label="财经类" value="1"></el-option>
				<el-option label="文学类" value="2"></el-option>
				<el-option label="悬疑类" value="3"></el-option>
				<el-option label="小说类" value="4"></el-option>
				<el-option label="心理学" value="5"></el-option>
			</el-select>
			</el-form-item>
			<el-form-item label="书籍详情" prop="description">
				<el-input v-model="dataForm.description" placeholder=""></el-input>
			</el-form-item>
			<el-form-item label="库存" prop="store">
				<el-input-number v-model="dataForm.store" min="0" max="1000"></el-input-number>
			</el-form-item>
		</el-form>
		<template #footer>
			<el-button @click="visible = false">取消</el-button>
			<el-button type="primary" @click="submitHandle()">确定</el-button>
		</template>
	</el-dialog>
</template>

<script setup lang="ts">
import { reactive, ref } from 'vue'
import { ElMessage } from 'element-plus/es'
import { useT_bookApi, useT_bookSubmitApi } from '@/api/maku/t_book'
import { UploadProps } from 'element-plus'

const emit = defineEmits(['refreshDataList'])
const visible = ref(false)
const dataFormRef = ref()
const imageUrl = ref('')
const handleAvatarSuccess: UploadProps['onSuccess'] = (response, uploadFile) => {
	imageUrl.value = URL.createObjectURL(uploadFile.raw!)
}

const beforeAvatarUpload: UploadProps['beforeUpload'] = rawFile => {
	if (rawFile.type !== 'image/jpeg') {
		ElMessage.error('头像必须是jpg格式!')
		return false
	} else if (rawFile.size / 1024 / 1024 > 2) {
		ElMessage.error('图片不得大于2MB!')
		return false
	}
	return true
}

const dataForm = reactive({
	id: '',
	bookName: '',
	author: '',
	price: '',
	bookCover: '',
	introduction: '',
	description: '',
	store: '',
	createTime: '',
	updateTime: '',
	category:''
})

const init = (id?: number) => {
	visible.value = true
	dataForm.id = ''

	// 重置表单数据
	if (dataFormRef.value) {
		dataFormRef.value.resetFields()
	}

	if (id) {
		getT_book(id)
	}
}

const getT_book = (id: number) => {
	useT_bookApi(id).then(res => {
		Object.assign(dataForm, res.data)
	})
}

const dataRules = ref({
	bookName: [{ required: true, message: '必填项不能为空', trigger: 'blur' }],
	price: [{ required: true, message: '必填项不能为空', trigger: 'blur' }],
	store: [{ required: true, message: '必填项不能为空', trigger: 'blur' }],
	author:[{required: true, message: '必填项不能为空', trigger: 'blur'}],
	category:[{required: true, message: '必填项不能为空', trigger: 'blur'}]
})

// 表单提交
const submitHandle = () => {
	dataFormRef.value.validate((valid: boolean) => {
		if (!valid) {
			return false
		}

		useT_bookSubmitApi(dataForm).then(() => {
			ElMessage.success({
				message: '操作成功',
				duration: 500,
				onClose: () => {
					visible.value = false
					emit('refreshDataList')
				}
			})
		})
	})
}

defineExpose({
	init
})
</script>
